unit EQ_; //    (   )
interface
uses rk_;
// -----------------------------------------------------------------------
const xEnd = 17.065216560157962558917206249;
type
 	EQ = class								//  
   public
      b : array of array of extended;       				//   
      b2: array of array of extended;       				//   
      dim: integer;
      constructor Create_EQ;
      destructor Done_EQ;
      procedure Clear_EQ;
      procedure setRandom(dim_: integer; v: extended; var x: DVector);//    dim*dim,  [-v..v]
      procedure init(rk:RungeKutt; var x: DVector);						//   
      procedure f(rk:RungeKutt; var x,y: DVector);
      procedure saveTxt(rk:RungeKutt; fName: string);
    end;

implementation

uses math, common;

// -----------------------------------------------------------------------
constructor EQ.Create_EQ;
begin
	self.Clear_EQ;
end;
Destructor EQ.Done_EQ;
begin
	self.Clear_EQ;
end;
//-------------------------------------------------------------------------
procedure EQ.Clear_EQ;
begin
  b:=nil;
  b2:=nil;
  dim:=0;
end;
//-------------------------------------------------------------------------
procedure EQ.f(rk:RungeKutt; var x,y: DVector);
var i,j: integer;
begin
	if Length(x) <> dim then ErrProc(' EQ_04.f: Lenght(x) <> self.dim');
	for i:=0 to dim-1 do begin
		y[i]:=0;
		for j:=0 to dim-1 do begin
			y[i]:=y[i] + b[i,j]*x[j] + b2[i,j]*x[j]*x[j];
	    end;
    end;
end;
// -----------------------------------------------------------------------------
procedure EQ.setRandom(dim_: integer; v: extended; var x: DVector);//    dim*dim,  [-v..v]
var i,j: integer;
begin
    dim:=dim_;
    SetLength(self.b, dim_, dim_);
    SetLength(self.b2, dim_, dim_);
    SetLength(x, dim_);

	for i:=0 to dim_-1 do begin
		for j:=0 to dim_-1 do begin
			b [i,j] := v*(2*random-1);
			b2[i,j] := v*(2*random-1);
	    end;
        x[i]:=1;
    end;
end;
// -----------------------------------------------------------------------------
procedure EQ.init(rk:RungeKutt; var x: DVector);	//   
var i:integer;
begin
	if (dim<1) or (dim>100) then ErrProc('EQ_05.init: illegal self.dim');
    rk.t := 0;
    SetLength(x, dim);
	for i:=0 to dim-1 do begin
        x[i]:=1;
    end;
end;
// -----------------------------------------------------------------------------
procedure EQ.saveTxt(rk:RungeKutt; fName: string);
var f: text;
	i,j: integer;
begin
	hOpen(fName, f);
    WriteLn(f, 'EQ: dim=', rk.dim:3, '; Linear:');
	for i:=0 to dim-1 do begin
		for j:=0 to dim-1 do begin
		    Write(f, self.b[i,j]:10:6);
	    end;
        WriteLn(f);
    end;
    WriteLn(f, 'Quadratic:');
	for i:=0 to dim-1 do begin
		for j:=0 to dim-1 do begin
		    Write(f, self.b2[i,j]:10:6);
	    end;
        WriteLn(f);
    end;
    CloseFile(f);
end;
// -----------------------------------------------------------------------------
begin
end.



