program RK_use7; // 2008-03-30     
{$APPTYPE    CONSOLE}
uses
  math,
  common,
  rk_,
  EQ_;

//------------------------------------------------------------------------------
//  
const EQs_size = 1000; 						//   
	    RK_05_h = 0.01;
var	  EQs: array[0..EQs_size-1] of EQ;		//   
      r: RungeKutt;
      MSE,res : extended;
      koef: array[1..6] of extended;
//------------------------------------------------------------------------------
//        RK
// h  - 
procedure RK_step(r: RungeKutt; eqs: EQ; h:extended; var x: DVector);	//   -
var i,j: integer;
begin
	if r.N<2 then ErrProc('RK_step: N<2');
	r.initBuf( Length(x));

	for i:=1 to r.N do //  
    begin
		  cop_vect(r.xt, x);
	    for j:= 1 to i-1 do add_vect(r.xt, r.k[j], h*r.a[i,j]);
	    eqs.f(r, r.xt, r.k[i]);
    end;
    //  : x0 += h*(a[N+1,1]*k[1] + ... a[N+1,N]*k[n])
    for j:= 1 to r.N do add_vect(x, r.k[j], h*r.a[r.N+1,j]);
    r.t := r.t + h;
end;
//------------------------------------------------------------------------------
//    
function RK_StepError( r: RungeKutt; eqs: EQ; var x: DVector; h: extended):extended;
var y1, y2: DVector;
    t0: extended;
    e1, e2: extended;
begin
	t0 := r.t;						//  
	cop_vect(y1,x);
  RK_step(r,eqs,h/2,y1);
  RK_step(r,eqs,h/2,y1);         		//     h/2
	cop_vect(y2,x);
  r.t:=t0;
 	RK_step(r,eqs,h,y2);				//     h
  e1 := r.err(y2);
  e2 := r.dst_vect(y1,y2);
	result:=max(e1,e2);
  r.t:=t0;
end;
// -----------------------------------------------------------------------------
function midError(r: RungeKutt; var MSE:extended): extended; //     
var
  m: integer;
	err, err0, err2: extended;
  x0 : DVector;
begin
	err := 0;
  err2:= 0;
	for m:=0 to (EQs_size-1) do
    begin
        EQs[m].init(r,x0);						//    ( )
		    err0 := RK_StepError(r, EQs[m], x0, RK_05_h);
        err := err + err0;
        err2:= err2+ err0*err0;
    end;
	err := err/EQs_size;
  MSE := sqrt(err2/EQs_size - err*err);
  result := err;
end;
//------------------------------------------------------------------------------
procedure make_random_Eq;
const RK_05_v = 2;		//   RK_05
var
    x0: DVector;
    i, dim: integer;
begin
    RandSeed:=783;

    for i:=0 to EQs_size-1 do begin
		  EQs[i] := EQ.Create;
      dim := 3 + (i mod 10);
      EQs[i].setRandom(dim, RK_05_v, x0);
    end;
end;
//------------------------------------------------------------------------------
procedure done_random_methods;
var
    i: integer;
begin
    for i:=0 to EQs_size-1 do begin
		EQs[i].Done_EQ;
    end;
end;
//------------------------------------------------------------------------------
procedure izmenenie_c2_c3_c5(c6,h: extended); // 2, 3  c4   h
var
    c2,c3,c5,err0: extended;
begin
 c2:=0.205; c3:=0.285; c5:=0.875;
 while c2<0.215 do
  begin
   c2:=c2+h;
   while c3<0.295 do
    begin
     c3:=c3+h;
     while c5<0.885 do
      begin
        r.set56n(c2,c3,c5,c6,h);
        err0:=r.max_coeff;
        if r.max_coeff>20 then begin c5:=c5+h; continue; end;
        r.save0('t.txt');
        err0:=midError(r, MSE);
        if err0<res then
          begin
            res:=err0;
            koef[1]:=c2;
            koef[2]:=c3;
            koef[3]:=c5;
            koef[4]:=c6;
          end;
        c5:=c5+h;
          WriteLn('err=',err0:12, ' c2=',c2:3:3,' c3=',c3:3:3,' c5=',c5:3:3,' c6=',c6:3:3);
      end;
      c5:=0.875;
    end;
    c3:=0.285;
  end;
end;
// -----------------------------------------------------------------------------
var
 c_6: extended;
begin
 r := RungeKutt.Create;
 make_random_EQ;  //   
 c_6:=0.845; res:=1000;
 while c_6<0.855 do
  begin
   izmenenie_c2_c3_c5(c_6, 0.001);
   c_6:=c_6+0.001;
   WriteLn('C6=',c_6:3:2);
  end;
 WriteLn('err=',res:12, ' c2=',koef[1]:3:3,' c3=',koef[2]:3:3,' c5=',koef[3]:3:3,' c6=',koef[4]:3:3);
 readln;

//	test_01;		//    ( RK_05),  RK(4,4)
 //test_02;		//  rk56
	//test_03;		// find a43
	//test_04;		//   a43
	//test_05;		//  rk56   a43
end.



